//+------------------------------------------------------------------+
//|                                       Nevalyashka_MartinGeil.mq4 |
//|                              Copyright  2011, cmillion@narod.ru |
//|                                         http://cmillion.narod.ru |
//-------------------------------------------------------------------+
#property copyright "Copyright  2011, http://cmillion.narod.ru"
#property link      "cmillion@narod.ru"
//-------------------------------------------------------------------- 
extern int    stoploss     = 50, 
              takeprofit   = 50; 
extern double Lot          = 0.1; 
extern double MartinGeil   = 2.0; 
extern int    TrailingStop = 10;//
int tip; 
double LOT;
double Profit;
//-------------------------------------------------------------------- 
int init() 
{ 
   double MinLot = MarketInfo(Symbol(),MODE_MINLOT);
   if (Lot<MinLot) Lot = MinLot; 
   if (Bid<iMA(NULL,0,14,0,MODE_SMA,PRICE_CLOSE,0))
   {
      OrderSend(Symbol(),OP_SELL,Lot,Bid,3,NormalizeDouble(Ask + stoploss*Point,Digits), 
                           NormalizeDouble(Bid - takeprofit*Point,Digits)," ",777,Blue); 
   }
   else
   {
      OrderSend(Symbol(),OP_BUY,Lot,Ask,3,NormalizeDouble(Bid - stoploss*Point,Digits), 
                           NormalizeDouble(Ask + takeprofit*Point,Digits)," ",777,Blue); 
   }
} 
//-------------------------------------------------------------------- 
int start() 
{ 
   int Ticket,STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double OSL,OOP,StLo;
   for (int i=0; i<OrdersTotal(); i++)
   {    
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      { 
         if (OrderSymbol()==Symbol())
         { 
            tip = OrderType(); 
            Lot = OrderLots();
            Profit = OrderProfit();
            if (tip<2)
            {
               OSL   = OrderStopLoss();
               OOP   = OrderOpenPrice();
               Ticket = OrderTicket();
               if (tip==OP_BUY)             
               {
                  StLo = NormalizeDouble(Bid-TrailingStop*Point,Digits);
                  if (StLo >= OOP && StLo <= NormalizeDouble(Bid-STOPLEVEL*Point,Digits) && StLo > OSL)
                  {  
                     if (!OrderModify(Ticket,OOP,NormalizeDouble(StLo,Digits),OrderTakeProfit(),0,White)) Print("Error order ",Ticket);
                  }
               }                                         
               if (tip==OP_SELL)        
               {
                  StLo = NormalizeDouble(Ask+TrailingStop*Point,Digits);
                  if (StLo <= OOP && StLo >= NormalizeDouble(Ask+STOPLEVEL*Point,Digits) && StLo < OSL || OSL==0)
                  {  
                     if (!OrderModify(Ticket,OOP,NormalizeDouble(StLo,Digits),OrderTakeProfit(),0,White)) Print("Error order ",Ticket);
                  }
               } 
            }
            return;
         }
      }
   } 
   if (Profit<0) LOT = Lot*MartinGeil; else LOT = Lot;
   double MAXLOT = MarketInfo(Symbol(),MODE_MAXLOT);
   double MaxLot = NormalizeDouble(AccountFreeMargin()/MarketInfo(Symbol(),MODE_MARGINREQUIRED),1);
   if (LOT>MAXLOT) LOT = MAXLOT; 
   if (LOT>MaxLot) LOT = MaxLot; 
   if (((tip==0 && Profit<0) || (tip==1 && Profit>0))) OrderSend(Symbol(),OP_SELL,LOT,Bid,3,
   NormalizeDouble(Ask + stoploss*Point,Digits),NormalizeDouble(Bid - takeprofit*Point,Digits)," ",777,Blue); 
   if (((tip==1 && Profit<0) || (tip==0 && Profit>0))) if (tip==1) OrderSend(Symbol(),OP_BUY ,LOT,Ask,3,
   NormalizeDouble(Bid - stoploss*Point,Digits),NormalizeDouble(Ask + takeprofit*Point,Digits)," ",777,Blue); 
   return(0); 
} 
//----------------------------------------------------------------- 